EDIT - feature request #4227

handle generated resources in eclipse workspace
05/28/2014 11:28 AM - Patrick Plitzner

Status: Feedback Start date:

Priority: Priority14 Due date:

Assignee: Andreas Muller % Done: 50%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.5

Severity: normal

Description

Some files in the eclipse workspace are generated/deleted/changed when maven goals are run or the classpath is updated etc.
leaving those files as outgoing svn changes which can be annoying.

e _classpath is changed when a new version is released
o This could be solved by using maven or by manually adjusting the version numbers of the cdmlib jars and then committing
it
¢ org.eclipse.equinox.common-.jar and org.eclipse.osgi-.jar appear as outgoing changes when running mvn clean validate on
taxeditor.cmlib

o Here we should investigate if these files are really needed in the svn repository or if they can be deleted

If removal from the svn repository is the proposed solution then it should be explicitely checked what happens when checking out a
completely fresh trunk version of the taxeditor project and if the standard steps to get it running work

Discussuion:

Hallo

muss eu.etaxonomy.taxeditor.cdmlib/.classpath den im repo sein? Ich finde das eher stérend denn die verandert man lokal ja auch,
oder eclipse macht das bei der Konfiguration des Workspaces.

Ich finde es jedenfalls recht lastig diese immer wieder vor jedem pull retten und danach wiederherstellen zu miissen.

Wart ihr damit einverstanden die aus dem repo heraus zu nehmen?

Andreas

Ich bin ja nicht der Editor Experte. Kann mich nur noch dunkel erinnern, dass das damals damit zu tun hatte, dass sich die .classpath
Datei nicht so einfach automatisch generieren lie3. Somit war es leichter, oder sogar notwendig, sie mit in git/svn aufzunehmen.
Kann das sein?

Viele GriBe,

Andreas M.

ich habe ich gerade mal bei mir geschaut. Bei mir &ndert sich die Datei nie. Also zumindest nicht automatisch durch Eclipse oder
mvn validate.

Und wenn ich die Datei I6sche, dann ist natarlich der Workspace rot. Sie wird allerdings auch nicht neu erstellt. Weder durch maven,
noch durch Eclipse.

Gruf3,

Patrick

also bei mir &ndert sie sich, z.B. wenn ich Code Quellen hinzuftige. Daher kenne ich das Problem schon auch.
Aber das Problem, dass sie nicht automatisch erstellt werden kann, hatte ich auch so in Erinnerung. Andreas K., hast du da andere
Erkenntnisse?

Viele Grife,
Andreas M.

wenn fir eu.etaxonomy.taxeditor.cdmlib modul PluginTools->Update ClassPath .. laufen lasse wird diese Datei doch neu erstellt,
zumindest bei mir.

Wenn ich das mache, dann habe ich auch Anderungen. Allerdings musste ich
das schon Ewigkeiten nicht mehr machen.

Wenn man die Datei [6scht und das dann probiert, kommt eine Exception.

Vielleicht ist das genau das aktuelle Problem: Man braucht eine
vorhanden .classpath-Datei, um die Operation auszuflhren -> Also muss
die Datei ins git, weil sie nicht automatisch erzeugt wird. Wenn man sie
dann allerdings aktualisiert, damit man alle Abh&ngigkeiten im Workspace
resolven kann, wird sie dabei immer veréndert.

Ich habe genau das gemacht: Datei geléscht, und PluginTools->Update ClassPath .. ausgefuhrt, und bekam keine Exception, hat
schon 2x geklappt.
Ich fihre dies fur diesen Test allerdings nur auf eu.etaxonomy.taxeditor.cdmlib aus.

Andreas

Dass diese Exception bei dir, Patrick, entsteht, ist auch nicht schdn, daher schlage ich vor, dass wir dieses .classpath nicht komplett
I6schen, sondern in .classpath.template umbenennen. Dann hat man sie zur Verfiigung, falls PluginTools->Update ClassPath ..
Probleme macht und im Normalfall stért sie nicht.

Update ClassPath" muss ich tatsachlich immer ausfiihren.

ich teste nochmals den kompletten Setup-Prozess und habe hierbei eine Frage: Bei mir stimme anscheinend die target
Platform-Einstellungen nicht und die Anleitungen auf https://cybertaxonomy.eu/taxeditor/getting-started.html und
https://dev.e-taxonomy.eu/redmine/projects/edit/wiki/TaxonomicEditorDevelopersGuide#Target-RCP-Environment helfen mir leider
nicht weiter

Associated revisions

Revision c3b22cae - 07/03/2018 08:40 AM - Andreas Kohlbecker

ref #4227 eu.etaxonomy.taxeditor.cdmlib/.classpath.template

Revision 5cded95c - 07/03/2018 11:58 AM - Andreas Kohlbecker
ref #4227 deleting all .classpath and .project files

Revision 2cd5eebf - 01/17/2019 03:31 PM - Andreas Kohlbecker

ref #4227 eu.etaxonomy.taxeditor.cdmlib/.classpath.template

Revision a6¢c4b9c2 - 01/17/2019 03:31 PM - Andreas Kohlbecker
ref #4227 deleting all .classpath and .project files

Revision e1e6ddc7 - 01/17/2019 03:42 PM - Andreas Kohlbecker
ref #4227 restoring setup-project.sh

Revision flae6ccd - 02/18/2019 01:55 PM - Patrick Plitzner
ref #4227 Fix file deletion in setup-project.sh

Revision b11e5ce8 - 02/18/2019 01:55 PM - Patrick Plitzner
https://cybertaxonomy.eu/taxeditor/getting-started.html
https://dev.e-taxonomy.eu/redmine/projects/edit/wiki/TaxonomicEditorDevelopersGuide#Target-RCP-Environment

ref #4227 Delete .settings folder for test and webapp plugin

Revision af7030a7 - 02/18/2019 01:55 PM - Patrick Plitzner
ref #4227 Trim .classpath template file

History

#1 - 05/12/2018 07:56 PM - Andreas Miiller

- Description updated

- Category changed from devQOps to taxeditor

- Assignee changed from Andreas Kohlbecker to Patrick Plitzner
- Priority changed from New to Priority14

- Target version changed from TaxEditor Next Major Release to Release 5.1

| remember this has been discussed recently. Is there a duplicate ticket? If not can you put email conversation and results into this ticket?

#2 - 05/18/2018 11:42 AM - Patrick Plitzner

- Description updated

#3 - 05/18/2018 11:45 AM - Patrick Plitzner
- Status changed from New to Feedback

- Assignee changed from Patrick Plitzner to Andreas Kohlbecker

@Andreas K.: Could you test again if it is possible to delete the .classpath file from taxeditor.cdmlib and run "Update classpath”. | still get an
exception when doing that. Also | don't really have to run "Update classpath" anymore which is why | would close this ticket as there are no more
generated resources in the taxeditor as far as | know.

#4 - 06/28/2018 12:24 AM - Andreas Miiller

- Private changed from Yes to No

#5 - 06/28/2018 08:26 AM - Andreas Kohlbecker

- Target version changed from Release 5.1 to Release 5.2

#6 - 07/02/2018 08:26 PM - Andreas Kohlbecker

The only generated resources which still is causing a conflict after setting up the project in eclipse is the
eu.etaxonomy.taxeditor.cdmlib/.classpath
This is because | always have to run "Update classpath”

| will quite soon try to delete this file and to setup the editor project in eclipse from scratch.

#7 - 07/02/2018 09:41 PM - Andreas Kohlbecker
- File error-1.png added

1. Projekt in Eclipse gel6scht

2. git workspace komplett ge-cleant mit git clean -x

3. rm eu.etaxonomy.taxeditor.cdmlib/.classpath

4. /setup-project.sh laufen lassen

5. Import in die eclipse mit "Import Existing Projects into Workspace" ....

6. Eclipse: "building Workspace" ... warten .... einige Projekte mit Fehler

7./eu.etaxonomy.taxeditor/rcp.target gedffnet ... Eclipse: "Resolving Target Definition" ... warten ... keine Fehler in der rcp.target
8. Plugin tools > Update Classpath auf eu.etaxonomy.taxeditor.cdmlib

jetzt bekomme ich auch einen Fehler:
o 2 Update Classpaths v~

Cannot nest 'eu.etaxonomy.taxeditor.cdmlib/sre/main/java/’ inside
'eu.etaxonomy.taxeditor.cdmlib’. To enable the nesting exclude 'src/ from
'eu.etaxonomy.taxeditor.cdmlib’

OK

... to be continued ...

#8 - 07/02/2018 09:58 PM - Andreas Kohlbecker

... das Problem ist offenbar, dass eclipse die maven source folder nicht erkennt und und eu.etaxonomy.taxeditor.cdmlib/src als source folder nimmt.
Strategie (A) m2 plugin:

1. Configure > convert to Maven Project
2. nun sind die source folder korrekt
3. Maven > Disable Maven Nature

Fehler
Dafir ist nun aber das komplette Projekt irgendwie zerschossen einige eclipse Abhangigkeiten werden nicht mehr gefunden :-(

das muss also anderst gehen ...

#9 - 07/02/2018 10:31 PM - Andreas Kohlbecker

... Mist ich hatte das "Set as Target Platform" vergessen, sonst hatte es wohl funktioniert, dies habe ich leider erst nach dem Durchspielen von
Strategie B erkannt, dort trat namlich das selbe Problem auf!

Strategie B :

1. eu.etaxonomy.taxeditor.cdmlib/.classpath.template als Kopie von eu.etaxonomy.taxeditor.cdmlib/.classpath allerdings ohne die cdmlib
dependencies (Vermutlich kann man alle lib/* dependencies entfernen)

2. setup-project.sh um cp -f eu.etaxonomy.taxeditor.cdmlib/.classpath.template eu.etaxonomy.taxeditor.cdmlib/.classpath erganzt

3. ./setup-project.sh laufen lassen

4. Import in die eclipse mit "Import Existing Projects into Workspace" ....

5. Eclipse: "building Workspace" ... warten ... einige Projekte mit Fehler

6. /eu.etaxonomy.taxeditor/rcp.target gedffnet ... Eclipse: "Resolving Target Definition" ... warten ... keine Fehler in der rcp.target

7.nun im rcp.target editor "Set as Target Platform" 1- FERITG!!!!

#10 - 07/02/2018 10:55 PM - Andreas Kohlbecker

also nochmal die Strategie (A) mit m2 plugin aber ganz von vorn und unter Einbeziehung der bisherigen Erkentnisse:

1. Projekt in Eclipse gel6scht

2. git workspace komplett ge-cleant mit git clean -x

3. rm eu.etaxonomy.taxeditor.cdmlib/.classpath

4. ./setup-project.sh laufen lassen

5. Import in die eclipse mit "Import Existing Projects into Workspace" ....

6. Eclipse: "building Workspace" ... warten .... einige Projekte mit Fehler

7. leu.etaxonomy.taxeditor/rcp.target gedffnet ... Eclipse: "Resolving Target Definition" ... warten ... keine Fehler in der rcp.target
8. nun im rcp.target editor "Set as Target Platform" 1- FERITG!!!!

Es war kein "Plugin tools > Update Classpath" mehr notig
FAZIT:

1. Die Plugin tools > Update Classpath kann getrost aus dem git repository geldscht werden, denn es gibt zwei Wege sie zu erzeugen.
. v ifiakationen-an-eu-etaxonomy-taxeditor-cdmlib/classpath-und-somit-auch-die Konflikte-entstehenle ichja-nur-dadu ,(Korrektur:das
ist Quatsch!!l!) dass die maven dependencies in diesem .classpath file stehen und nicht Giber maven verwaltet werden. Ticket #5752 betrifft
dieses Thema auch. Hier geht es aber anscheinend lediglich darum unbeétigte jars in den lib/ Ordnern zu I6schen. Eigentlich sollten da aber gar
keine sein oder? Das kann mittels des maven-dependency-plugin gemacht werden, wie in /eu.etaxonomy.taxeditor.webapp/pom.xml schon
teilweise realisiert:

<plugin>
<groupld>org.apache.maven.plugins</groupId>
https://dev.e-taxonomy.eu/redmine/issues/5752

<artifactId>maven-dependency-plugin</artifactId>
<version>2.4</version>
<executions>
<execution>
<id>copy-dependency-war</id>
<phase>validate</phase>
<goals>
<goal>copy-dependencies</goal>
</goals>
<configuration>
<includeArtifactIds>
cdmlib-remote-webapp
</includeArtifactIds>
<outputDirectory>
S{basedir}/1lib
</outputDirectory>
<overWriteReleases>true</overWriteReleases>
<overWriteSnapshots>true</overWriteSnapshots>
<excludeTransitive>true</excludeTransitive>
</configuration>
</execution>
<execution>
<id>copy-dependency-jars</id>
<phase>validate</phase>
<goals>
<goal>copy-dependencies</goal>
</goals>
<configuration>
<includeArtifactIds>
log4j, javax.servlet-api, jetty-all
</includeArtifactIds>
<outputDirectory>
S{basedir}/1lib
</outputDirectory>
<overWriteReleases>true</overWriteReleases>
<overWriteSnapshots>true</overWriteSnapshots>
<excludeTransitive>true</excludeTransitive>
</configuration>
</execution>
<execution>
<id>copy-dependency-jars—-transitive</id>
<phase>validate</phase>
<goals>
<goal>copy-dependencies</goal>
</goals>
<configuration>
<includeArtifactIds>
c3p0, mchange-commons—java, h2, postgresqgl, mysgl-connector-java, jdbc4
</includeArtifactIds>
<outputDirectory>
S{basedir}/1lib
</outputDirectory>
<overWriteReleases>true</overWriteReleases>
<overWriteSnapshots>true</overWriteSnapshots>
<excludeTransitive>false</excludeTransitive>
</configuration>
</execution>
</executions>
</plugin>

#11 - 07/02/2018 11:01 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Patrick Plitzner

Hiermit ist mein Monster-Feedback #4227#note-7 bis #4227#note-10 zu Ende.

und ich bin der Meinung, dass eu.etaxonomy.taxeditor.cdmlib/.classpath geldscht werden sollte.

Die beiden Setup Strategien A und B sollten in die Editor Dokumentation (TaxonomicEditorDevelopersGuide und
https://cybertaxonomy.eu/taxeditor/getting-started.html) mit aufgenommen werden. Fir B missen natarlich vorher die 2 kleinen Anderung eingebaut
werden. Diesen letzten Punkt Gbernehme ich gerne, sofern alle einverstanden sind.

#12 - 07/02/2018 11:01 PM - Andreas Kohlbecker
- % Done changed from 0 to 40
https://dev.e-taxonomy.eu/redmine/issues/4227#note-7
https://dev.e-taxonomy.eu/redmine/issues/4227#note-10
https://dev.e-taxonomy.eu/redmine/projects/edit/wiki/TaxonomicEditorDevelopersGuide
https://cybertaxonomy.eu/taxeditor/getting-started.html

#13 - 07/03/2018 09:13 AM - Andreas Kohlbecker

Ich habe heute morgen noch eine radikalere Strategie getestet - Stratregie A+:

1. Projekt in Eclipse geldscht, eclipse neu gestaretet

2. Alle .classpath und .project files geldscht (find -type f -name ".classpath" -or -name ".project" -prune -exec rm {} \;), die **/.settings/*.pref files
habe ich vergessen, aber das sollte keinen Einfluss haben.

3. ./setup-project.sh

4. Import in eclipse als "Existing Maven Project” ...

5. ... warten auf "Building Workspace"

6. /eu.etaxonomy.taxeditor/rcp.target gedffnet ... Eclipse: "Resolving Target Definition" ... warten ... keine Fehler in der rcp.target

7.nun im rcp.target editor "Set as Target Platform" 1- FERITG!!!!

Wir kénnen also auf alle .classpath und .project files im git Repositorium verzichten.

Wenn man Probleme damit hat, dass flr die Taxeditor-Projekte die Maven Nature aktiv ist, oder m2 einfach nicht mag, kann diese auch wieder
deaktiviert werden nachdem das Projektsetup komplett und fehlerfrei ist: Maven > Disable Maven Nature

#14 - 07/03/2018 09:25 AM - Andreas Kohlbecker
auch der Wechsel auf einen anderen Branch klappt mit diesem Setup problemlos:
1. start im develop branch
2. git checkout hotfix/5.1.2
3. ./setup-project
4. fur alle taxeditor projekte: Maven > Update Project Alt+F5
und Alles ist gut!
#15 - 07/03/2018 12:04 PM - Andreas Kohlbecker
Ich habe einen branch generated-resources committed in dem alle .classpath and .project files geldscht sind: taxeditor|5cded95¢c
Bitte tested doch alle einmal ob Stratregie A+ fiir euch funktioniert oder Probleme verursacht.
Ich verwende Ubrigens
Spring Tool Suite
Version: 3.9.4.RELEASE
Build Id: 201804120943
Platform: Eclipse Neon.3 (4.6.3)
mit m2e 1.8.3.20180227
#16 - 07/04/2018 04:48 PM - Andreas Kohlbecker
- Assignee changed from Patrick Plitzner to Andreas Miiller

[Patrick has tested strategy A+, these are his results:]

® had to apply the /cdmlib-parent/lifecycle-mapping-metadata.xml to Preference > Maven > Lifecycle to fix m2e problems with pom.xml
e Strategie A+ klappt!

zudem:

jetzt teste ich gerade das Ganze ohne m2e-Plugin

https://maven.apache.org/plugins/maven-eclipse-plugin/ : "Disclaimer: Users are advised to use m2e, the Eclipse Maven Integration instead of
this plugin”

Na dann muss ich das wohl nicht mehr testen

Who will test next, Andreas Muller?

#17 - 07/04/2018 04:50 PM - Patrick Plitzner

- File maven_plugin_connectors.png added

| tried the A+ strategy and it worked fine.

1. git checkout generated-resources
2. run setup-project.sh
3. Install m2e feature (if not already installed) in eclipse
o Update-Site: http://download.eclipse.org/releases/neon
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/5cded95c834077fdc9b871324274ece5d05e0236
https://maven.apache.org/plugins/maven-eclipse-plugin/
http://download.eclipse.org/releases/neon

o Feature to install: m2e - Maven Integration for Eclipse
4. Import projects as maven projects into the eclipse workspace
o Note: A dialog pops up to import the missing maven connectors saying that a mapping for antrun is missing. Just install all connectors that
are available. The problem with antrun will then be solved by importing cdmlib/lifecycle-mapping-metadata.xml in the preferences under
Maven->Lifecycle Mappings->Change mapping file locatior

» % maven-antrun-plugin:1.7:run (3 errors) Resolve Later
» @ maven-clean-pluain:2.5:clean Install Tveho Confiaurator bridaes fucho base

5. Open /eu.etaxonomy.taxeditor/rcp.target and let it resolve all dependencies
6. Click "Set as target platform"

#18 - 07/04/2018 04:53 PM - Andreas Kohlbecker

- Assignee changed from Andreas Miiller to Katja Luther
Patrick and | decided that you will be the next tester.

#19 - 08/03/2018 04:06 PM - Katja Luther
| still have the error message

Plugin execution not covered by lifecycle configuration: org.apache.maven.plugins:maven-antrun-plugin:1.7:run (execution:
update-snapshot-jar-names, phase: validate) in cdmlib, molecular.lib und webapp

but the editor starts and works.

#20 - 08/03/2018 04:57 PM - Andreas Kohlbecker
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 40 to 50

Katja Luther wrote:
| still have the error message

Plugin execution not covered by lifecycle configuration: org.apache.maven.plugins:maven-antrun-plugin:1.7:run (execution:
update-snapshot-jar-names, phase: validate) in cdmlib, molecular.lib und webapp

Die lifecycle-mapping-metadata.xml hast du aber schon importiert, oder? Damit dlrfte das garnicht mehr auftauchen. Denn dort ist die fehlende
Konfiguration enthalten:

<pluginExecution>

<pluginExecutionFilter>
<groupId>org.apache.maven.plugins</groupId>
<artifactId>maven-antrun-plugin</artifactId>
<goals>

<goal>run</goal>

</goals>
<versionRange>[1.7,)</versionRange>

</pluginExecutionFilter>

<action>
<execute/>

</action>

</pluginExecution>

but the editor starts and works.

Das ist prima, dann muss nur noch Adreas M. testen

#21 - 08/20/2018 12:39 PM - Andreas Miiller

- Target version changed from Release 5.2 to Release 5.3

#22 - 09/05/2018 01:13 PM - Andreas Miiller

- Target version changed from Release 5.3 to Release 5.4

#23 - 10/17/2018 10:47 AM - Andreas Miiller

- Target version changed from Release 5.4 to Release 5.5

Files
error-1.png 21.5 KB 07/02/2018 Andreas Kohlbecker
maven_plugin_connectors.png 10.7 KB 07/04/2018 Patrick Plitzner
